#pragma once

#include <stdlib.h>
#include <stdbool.h>

#include "eccrsh.h"

#define AUTH_PROOF_SIZE (6*32)

#define AUTH_KEY1 0x1
#define AUTH_KEY2 0x2
#define AUTH_KEY3 0x4

bool auth_prove(const uint8_t basepoint_table[256][96],
	const ge25519* pk1, const ge25519* pk2, const ge25519* pk3,
	unsigned char knownKey, const bignum256modm sk,
	const unsigned char* message, size_t msgLen, const unsigned char* associatedData, size_t adLen,
	const unsigned char* implHashTag, size_t ihtLen,
	unsigned char* proof);

bool auth_verify(const uint8_t basepoint_table[256][96],
	const ge25519* pk1, const ge25519* pk2, const ge25519* pk3,
	const unsigned char* proof,
	const unsigned char* message, size_t msgLen, const unsigned char* associatedData, size_t adLen,
	const unsigned char* implHashTag, size_t ihtLen);
