#pragma once
#pragma GCC system_header

// Randomness source
#include <openssl/rand.h>

// SHA-3 hash
#include "SimpleFIPS202.h"
#include "KeccakHash.h"
#include "KeccakSponge.h"

// Ed25519 curve
#define ED25519_FN(fn) fn
#include "ed25519-donna.h"
#include "ed25519.h"
#include "ed25519-hash.h"
void ed25519_randombytes_unsafe(void *p, size_t len);

// SIDH key exchange
#ifdef QRKEX_USE_SIDH
#include "SIDH.h"
#endif

// New Hope key exchange
#ifdef QRKEX_USE_NEWHOPE
#include "newhope.h"
#endif
