#pragma once

#include <stdlib.h>
#include <stdbool.h>

#include "ecelgamal.h"
#include "aead.h"

#define DRE_CT_OVERHEAD (2*ECELGAMAL_CT_POINT_SIZE + AEAD_TAG_SIZE + 3*32)
#define DRE_KEY1 1
#define DRE_KEY2 2

bool dre_encrypt(const ecelgamal_pubkey* pk1, const ecelgamal_pubkey* pk2,
	const unsigned char* plaintext, size_t ptLen, const unsigned char* associatedData, size_t adLen,
	unsigned char* ciphertext, size_t ctMax, size_t* ctUsed);

bool dre_decrypt(const ecelgamal_pubkey* pk1, const ecelgamal_pubkey* pk2, unsigned char knownKey, const ecelgamal_seckey* sk,
	const unsigned char* ciphertext, size_t ctLen, const unsigned char* associatedData, size_t adLen,
	unsigned char* plaintext, size_t ptMax, size_t* ptUsed);
