#pragma once

#include <stdlib.h>
#include <stdbool.h>

typedef struct {
	size_t sizePqI;
	size_t sizeSqI;
	size_t sizeQR;
	size_t sizeKey;
	size_t sizeScratch;
	size_t sizeAlign8;  //Alignment offset for pointers where (p % 32) == 8
	size_t sizeAlign16; //Alignment offset for pointers where (p % 32) == 16
	size_t sizeAlign24; //Alignment offset for pointers where (p % 32) == 24

	bool (*qrInit)();
	bool (*qrGenI)(unsigned char* pqI, unsigned char* sqI, unsigned char* scratch);
	bool (*qrGenR)(const unsigned char* pqI, unsigned char* qR, unsigned char* key, unsigned char* scratch);
	bool (*qrKeyI)(const unsigned char* sqI, const unsigned char* qR, unsigned char* key, unsigned char* scratch);
	void (*qrCleanup)();
} qrKex;

extern qrKex* qrKexNone;

#ifdef QRKEX_USE_SIDH
extern qrKex* qrKexSIDH;
#endif

#ifdef QRKEX_USE_NEWHOPE
extern qrKex* qrKexNewHope;
#endif
