#pragma once

#include <stdlib.h>

// Returns the page size for secure memory regions, or 0 if none are available.
size_t securePageSize(void);

// Allocates secure memory pages for secret data of size pages*securePageSize().
void* mallocSecurePage(size_t pages);

// Securely erases data within a secure memory page.
void secureErase(void* ptr, size_t size);

// Releases a secure memory page. Note that the contents are not erased first.
void freeSecurePage(void* ptr);
