#include "batcher.h"
#include "params.h"


#define compare_and_swap(x,i,j) \
  c = _5q - 1 - x[16*i];\
  c >>= 31;\
  t = x[16*i] ^ x[16*j];\
  t &= c;\
  x[16*i] ^= t;\
  x[16*j] ^= t;


void batcher84(uint16_t *x)
{    
  const uint16_t _5q = 5*PARAM_Q;
  int32_t c;
  uint16_t t;

  compare_and_swap(x, 0, 1);
  compare_and_swap(x, 2, 3);
  compare_and_swap(x, 0, 2);
  compare_and_swap(x, 1, 3);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 4, 5);
  compare_and_swap(x, 6, 7);
  compare_and_swap(x, 4, 6);
  compare_and_swap(x, 5, 7);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 0, 4);
  compare_and_swap(x, 2, 6);
  compare_and_swap(x, 2, 4);
  compare_and_swap(x, 1, 5);
  compare_and_swap(x, 3, 7);
  compare_and_swap(x, 3, 5);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 3, 4);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 8, 9);
  compare_and_swap(x, 10, 11);
  compare_and_swap(x, 8, 10);
  compare_and_swap(x, 9, 11);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 12, 13);
  compare_and_swap(x, 14, 15);
  compare_and_swap(x, 12, 14);
  compare_and_swap(x, 13, 15);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 8, 12);
  compare_and_swap(x, 10, 14);
  compare_and_swap(x, 10, 12);
  compare_and_swap(x, 9, 13);
  compare_and_swap(x, 11, 15);
  compare_and_swap(x, 11, 13);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 11, 12);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 0, 8);
  compare_and_swap(x, 4, 12);
  compare_and_swap(x, 4, 8);
  compare_and_swap(x, 2, 10);
  compare_and_swap(x, 6, 14);
  compare_and_swap(x, 6, 10);
  compare_and_swap(x, 2, 4);
  compare_and_swap(x, 6, 8);
  compare_and_swap(x, 10, 12);
  compare_and_swap(x, 1, 9);
  compare_and_swap(x, 5, 13);
  compare_and_swap(x, 5, 9);
  compare_and_swap(x, 3, 11);
  compare_and_swap(x, 7, 15);
  compare_and_swap(x, 7, 11);
  compare_and_swap(x, 3, 5);
  compare_and_swap(x, 7, 9);
  compare_and_swap(x, 11, 13);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 3, 4);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 7, 8);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 11, 12);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 16, 17);
  compare_and_swap(x, 18, 19);
  compare_and_swap(x, 16, 18);
  compare_and_swap(x, 17, 19);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 20, 21);
  compare_and_swap(x, 22, 23);
  compare_and_swap(x, 20, 22);
  compare_and_swap(x, 21, 23);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 16, 20);
  compare_and_swap(x, 18, 22);
  compare_and_swap(x, 18, 20);
  compare_and_swap(x, 17, 21);
  compare_and_swap(x, 19, 23);
  compare_and_swap(x, 19, 21);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 19, 20);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 24, 25);
  compare_and_swap(x, 26, 27);
  compare_and_swap(x, 24, 26);
  compare_and_swap(x, 25, 27);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 28, 29);
  compare_and_swap(x, 30, 31);
  compare_and_swap(x, 28, 30);
  compare_and_swap(x, 29, 31);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 24, 28);
  compare_and_swap(x, 26, 30);
  compare_and_swap(x, 26, 28);
  compare_and_swap(x, 25, 29);
  compare_and_swap(x, 27, 31);
  compare_and_swap(x, 27, 29);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 27, 28);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 16, 24);
  compare_and_swap(x, 20, 28);
  compare_and_swap(x, 20, 24);
  compare_and_swap(x, 18, 26);
  compare_and_swap(x, 22, 30);
  compare_and_swap(x, 22, 26);
  compare_and_swap(x, 18, 20);
  compare_and_swap(x, 22, 24);
  compare_and_swap(x, 26, 28);
  compare_and_swap(x, 17, 25);
  compare_and_swap(x, 21, 29);
  compare_and_swap(x, 21, 25);
  compare_and_swap(x, 19, 27);
  compare_and_swap(x, 23, 31);
  compare_and_swap(x, 23, 27);
  compare_and_swap(x, 19, 21);
  compare_and_swap(x, 23, 25);
  compare_and_swap(x, 27, 29);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 19, 20);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 23, 24);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 27, 28);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 0, 16);
  compare_and_swap(x, 8, 24);
  compare_and_swap(x, 8, 16);
  compare_and_swap(x, 4, 20);
  compare_and_swap(x, 12, 28);
  compare_and_swap(x, 12, 20);
  compare_and_swap(x, 4, 8);
  compare_and_swap(x, 12, 16);
  compare_and_swap(x, 20, 24);
  compare_and_swap(x, 2, 18);
  compare_and_swap(x, 10, 26);
  compare_and_swap(x, 10, 18);
  compare_and_swap(x, 6, 22);
  compare_and_swap(x, 14, 30);
  compare_and_swap(x, 14, 22);
  compare_and_swap(x, 6, 10);
  compare_and_swap(x, 14, 18);
  compare_and_swap(x, 22, 26);
  compare_and_swap(x, 2, 4);
  compare_and_swap(x, 6, 8);
  compare_and_swap(x, 10, 12);
  compare_and_swap(x, 14, 16);
  compare_and_swap(x, 18, 20);
  compare_and_swap(x, 22, 24);
  compare_and_swap(x, 26, 28);
  compare_and_swap(x, 1, 17);
  compare_and_swap(x, 9, 25);
  compare_and_swap(x, 9, 17);
  compare_and_swap(x, 5, 21);
  compare_and_swap(x, 13, 29);
  compare_and_swap(x, 13, 21);
  compare_and_swap(x, 5, 9);
  compare_and_swap(x, 13, 17);
  compare_and_swap(x, 21, 25);
  compare_and_swap(x, 3, 19);
  compare_and_swap(x, 11, 27);
  compare_and_swap(x, 11, 19);
  compare_and_swap(x, 7, 23);
  compare_and_swap(x, 15, 31);
  compare_and_swap(x, 15, 23);
  compare_and_swap(x, 7, 11);
  compare_and_swap(x, 15, 19);
  compare_and_swap(x, 23, 27);
  compare_and_swap(x, 3, 5);
  compare_and_swap(x, 7, 9);
  compare_and_swap(x, 11, 13);
  compare_and_swap(x, 15, 17);
  compare_and_swap(x, 19, 21);
  compare_and_swap(x, 23, 25);
  compare_and_swap(x, 27, 29);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 3, 4);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 7, 8);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 11, 12);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 15, 16);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 19, 20);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 23, 24);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 27, 28);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 32, 33);
  compare_and_swap(x, 34, 35);
  compare_and_swap(x, 32, 34);
  compare_and_swap(x, 33, 35);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 36, 37);
  compare_and_swap(x, 38, 39);
  compare_and_swap(x, 36, 38);
  compare_and_swap(x, 37, 39);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 32, 36);
  compare_and_swap(x, 34, 38);
  compare_and_swap(x, 34, 36);
  compare_and_swap(x, 33, 37);
  compare_and_swap(x, 35, 39);
  compare_and_swap(x, 35, 37);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 35, 36);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 40, 41);
  compare_and_swap(x, 42, 43);
  compare_and_swap(x, 40, 42);
  compare_and_swap(x, 41, 43);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 44, 45);
  compare_and_swap(x, 46, 47);
  compare_and_swap(x, 44, 46);
  compare_and_swap(x, 45, 47);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 40, 44);
  compare_and_swap(x, 42, 46);
  compare_and_swap(x, 42, 44);
  compare_and_swap(x, 41, 45);
  compare_and_swap(x, 43, 47);
  compare_and_swap(x, 43, 45);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 43, 44);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 32, 40);
  compare_and_swap(x, 36, 44);
  compare_and_swap(x, 36, 40);
  compare_and_swap(x, 34, 42);
  compare_and_swap(x, 38, 46);
  compare_and_swap(x, 38, 42);
  compare_and_swap(x, 34, 36);
  compare_and_swap(x, 38, 40);
  compare_and_swap(x, 42, 44);
  compare_and_swap(x, 33, 41);
  compare_and_swap(x, 37, 45);
  compare_and_swap(x, 37, 41);
  compare_and_swap(x, 35, 43);
  compare_and_swap(x, 39, 47);
  compare_and_swap(x, 39, 43);
  compare_and_swap(x, 35, 37);
  compare_and_swap(x, 39, 41);
  compare_and_swap(x, 43, 45);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 35, 36);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 39, 40);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 43, 44);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 48, 49);
  compare_and_swap(x, 50, 51);
  compare_and_swap(x, 48, 50);
  compare_and_swap(x, 49, 51);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 52, 53);
  compare_and_swap(x, 54, 55);
  compare_and_swap(x, 52, 54);
  compare_and_swap(x, 53, 55);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 48, 52);
  compare_and_swap(x, 50, 54);
  compare_and_swap(x, 50, 52);
  compare_and_swap(x, 49, 53);
  compare_and_swap(x, 51, 55);
  compare_and_swap(x, 51, 53);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 51, 52);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 56, 57);
  compare_and_swap(x, 58, 59);
  compare_and_swap(x, 56, 58);
  compare_and_swap(x, 57, 59);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 60, 61);
  compare_and_swap(x, 62, 63);
  compare_and_swap(x, 60, 62);
  compare_and_swap(x, 61, 63);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 56, 60);
  compare_and_swap(x, 58, 62);
  compare_and_swap(x, 58, 60);
  compare_and_swap(x, 57, 61);
  compare_and_swap(x, 59, 63);
  compare_and_swap(x, 59, 61);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 59, 60);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 48, 56);
  compare_and_swap(x, 52, 60);
  compare_and_swap(x, 52, 56);
  compare_and_swap(x, 50, 58);
  compare_and_swap(x, 54, 62);
  compare_and_swap(x, 54, 58);
  compare_and_swap(x, 50, 52);
  compare_and_swap(x, 54, 56);
  compare_and_swap(x, 58, 60);
  compare_and_swap(x, 49, 57);
  compare_and_swap(x, 53, 61);
  compare_and_swap(x, 53, 57);
  compare_and_swap(x, 51, 59);
  compare_and_swap(x, 55, 63);
  compare_and_swap(x, 55, 59);
  compare_and_swap(x, 51, 53);
  compare_and_swap(x, 55, 57);
  compare_and_swap(x, 59, 61);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 51, 52);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 55, 56);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 59, 60);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 32, 48);
  compare_and_swap(x, 40, 56);
  compare_and_swap(x, 40, 48);
  compare_and_swap(x, 36, 52);
  compare_and_swap(x, 44, 60);
  compare_and_swap(x, 44, 52);
  compare_and_swap(x, 36, 40);
  compare_and_swap(x, 44, 48);
  compare_and_swap(x, 52, 56);
  compare_and_swap(x, 34, 50);
  compare_and_swap(x, 42, 58);
  compare_and_swap(x, 42, 50);
  compare_and_swap(x, 38, 54);
  compare_and_swap(x, 46, 62);
  compare_and_swap(x, 46, 54);
  compare_and_swap(x, 38, 42);
  compare_and_swap(x, 46, 50);
  compare_and_swap(x, 54, 58);
  compare_and_swap(x, 34, 36);
  compare_and_swap(x, 38, 40);
  compare_and_swap(x, 42, 44);
  compare_and_swap(x, 46, 48);
  compare_and_swap(x, 50, 52);
  compare_and_swap(x, 54, 56);
  compare_and_swap(x, 58, 60);
  compare_and_swap(x, 33, 49);
  compare_and_swap(x, 41, 57);
  compare_and_swap(x, 41, 49);
  compare_and_swap(x, 37, 53);
  compare_and_swap(x, 45, 61);
  compare_and_swap(x, 45, 53);
  compare_and_swap(x, 37, 41);
  compare_and_swap(x, 45, 49);
  compare_and_swap(x, 53, 57);
  compare_and_swap(x, 35, 51);
  compare_and_swap(x, 43, 59);
  compare_and_swap(x, 43, 51);
  compare_and_swap(x, 39, 55);
  compare_and_swap(x, 47, 63);
  compare_and_swap(x, 47, 55);
  compare_and_swap(x, 39, 43);
  compare_and_swap(x, 47, 51);
  compare_and_swap(x, 55, 59);
  compare_and_swap(x, 35, 37);
  compare_and_swap(x, 39, 41);
  compare_and_swap(x, 43, 45);
  compare_and_swap(x, 47, 49);
  compare_and_swap(x, 51, 53);
  compare_and_swap(x, 55, 57);
  compare_and_swap(x, 59, 61);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 35, 36);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 39, 40);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 43, 44);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 47, 48);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 51, 52);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 55, 56);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 59, 60);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 0, 32);
  compare_and_swap(x, 16, 48);
  compare_and_swap(x, 16, 32);
  compare_and_swap(x, 8, 40);
  compare_and_swap(x, 24, 56);
  compare_and_swap(x, 24, 40);
  compare_and_swap(x, 8, 16);
  compare_and_swap(x, 24, 32);
  compare_and_swap(x, 40, 48);
  compare_and_swap(x, 4, 36);
  compare_and_swap(x, 20, 52);
  compare_and_swap(x, 20, 36);
  compare_and_swap(x, 12, 44);
  compare_and_swap(x, 28, 60);
  compare_and_swap(x, 28, 44);
  compare_and_swap(x, 12, 20);
  compare_and_swap(x, 28, 36);
  compare_and_swap(x, 44, 52);
  compare_and_swap(x, 4, 8);
  compare_and_swap(x, 12, 16);
  compare_and_swap(x, 20, 24);
  compare_and_swap(x, 28, 32);
  compare_and_swap(x, 36, 40);
  compare_and_swap(x, 44, 48);
  compare_and_swap(x, 52, 56);
  compare_and_swap(x, 2, 34);
  compare_and_swap(x, 18, 50);
  compare_and_swap(x, 18, 34);
  compare_and_swap(x, 10, 42);
  compare_and_swap(x, 26, 58);
  compare_and_swap(x, 26, 42);
  compare_and_swap(x, 10, 18);
  compare_and_swap(x, 26, 34);
  compare_and_swap(x, 42, 50);
  compare_and_swap(x, 6, 38);
  compare_and_swap(x, 22, 54);
  compare_and_swap(x, 22, 38);
  compare_and_swap(x, 14, 46);
  compare_and_swap(x, 30, 62);
  compare_and_swap(x, 30, 46);
  compare_and_swap(x, 14, 22);
  compare_and_swap(x, 30, 38);
  compare_and_swap(x, 46, 54);
  compare_and_swap(x, 6, 10);
  compare_and_swap(x, 14, 18);
  compare_and_swap(x, 22, 26);
  compare_and_swap(x, 30, 34);
  compare_and_swap(x, 38, 42);
  compare_and_swap(x, 46, 50);
  compare_and_swap(x, 54, 58);
  compare_and_swap(x, 2, 4);
  compare_and_swap(x, 6, 8);
  compare_and_swap(x, 10, 12);
  compare_and_swap(x, 14, 16);
  compare_and_swap(x, 18, 20);
  compare_and_swap(x, 22, 24);
  compare_and_swap(x, 26, 28);
  compare_and_swap(x, 30, 32);
  compare_and_swap(x, 34, 36);
  compare_and_swap(x, 38, 40);
  compare_and_swap(x, 42, 44);
  compare_and_swap(x, 46, 48);
  compare_and_swap(x, 50, 52);
  compare_and_swap(x, 54, 56);
  compare_and_swap(x, 58, 60);
  compare_and_swap(x, 1, 33);
  compare_and_swap(x, 17, 49);
  compare_and_swap(x, 17, 33);
  compare_and_swap(x, 9, 41);
  compare_and_swap(x, 25, 57);
  compare_and_swap(x, 25, 41);
  compare_and_swap(x, 9, 17);
  compare_and_swap(x, 25, 33);
  compare_and_swap(x, 41, 49);
  compare_and_swap(x, 5, 37);
  compare_and_swap(x, 21, 53);
  compare_and_swap(x, 21, 37);
  compare_and_swap(x, 13, 45);
  compare_and_swap(x, 29, 61);
  compare_and_swap(x, 29, 45);
  compare_and_swap(x, 13, 21);
  compare_and_swap(x, 29, 37);
  compare_and_swap(x, 45, 53);
  compare_and_swap(x, 5, 9);
  compare_and_swap(x, 13, 17);
  compare_and_swap(x, 21, 25);
  compare_and_swap(x, 29, 33);
  compare_and_swap(x, 37, 41);
  compare_and_swap(x, 45, 49);
  compare_and_swap(x, 53, 57);
  compare_and_swap(x, 3, 35);
  compare_and_swap(x, 19, 51);
  compare_and_swap(x, 19, 35);
  compare_and_swap(x, 11, 43);
  compare_and_swap(x, 27, 59);
  compare_and_swap(x, 27, 43);
  compare_and_swap(x, 11, 19);
  compare_and_swap(x, 27, 35);
  compare_and_swap(x, 43, 51);
  compare_and_swap(x, 7, 39);
  compare_and_swap(x, 23, 55);
  compare_and_swap(x, 23, 39);
  compare_and_swap(x, 15, 47);
  compare_and_swap(x, 31, 63);
  compare_and_swap(x, 31, 47);
  compare_and_swap(x, 15, 23);
  compare_and_swap(x, 31, 39);
  compare_and_swap(x, 47, 55);
  compare_and_swap(x, 7, 11);
  compare_and_swap(x, 15, 19);
  compare_and_swap(x, 23, 27);
  compare_and_swap(x, 31, 35);
  compare_and_swap(x, 39, 43);
  compare_and_swap(x, 47, 51);
  compare_and_swap(x, 55, 59);
  compare_and_swap(x, 3, 5);
  compare_and_swap(x, 7, 9);
  compare_and_swap(x, 11, 13);
  compare_and_swap(x, 15, 17);
  compare_and_swap(x, 19, 21);
  compare_and_swap(x, 23, 25);
  compare_and_swap(x, 27, 29);
  compare_and_swap(x, 31, 33);
  compare_and_swap(x, 35, 37);
  compare_and_swap(x, 39, 41);
  compare_and_swap(x, 43, 45);
  compare_and_swap(x, 47, 49);
  compare_and_swap(x, 51, 53);
  compare_and_swap(x, 55, 57);
  compare_and_swap(x, 59, 61);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 3, 4);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 7, 8);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 11, 12);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 15, 16);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 19, 20);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 23, 24);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 27, 28);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 31, 32);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 35, 36);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 39, 40);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 43, 44);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 47, 48);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 51, 52);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 55, 56);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 59, 60);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 64, 65);
  compare_and_swap(x, 66, 67);
  compare_and_swap(x, 64, 66);
  compare_and_swap(x, 65, 67);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 68, 69);
  compare_and_swap(x, 70, 71);
  compare_and_swap(x, 68, 70);
  compare_and_swap(x, 69, 71);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 64, 68);
  compare_and_swap(x, 66, 70);
  compare_and_swap(x, 66, 68);
  compare_and_swap(x, 65, 69);
  compare_and_swap(x, 67, 71);
  compare_and_swap(x, 67, 69);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 67, 68);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 72, 73);
  compare_and_swap(x, 74, 75);
  compare_and_swap(x, 72, 74);
  compare_and_swap(x, 73, 75);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 76, 77);
  compare_and_swap(x, 78, 79);
  compare_and_swap(x, 76, 78);
  compare_and_swap(x, 77, 79);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 72, 76);
  compare_and_swap(x, 74, 78);
  compare_and_swap(x, 74, 76);
  compare_and_swap(x, 73, 77);
  compare_and_swap(x, 75, 79);
  compare_and_swap(x, 75, 77);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 75, 76);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 64, 72);
  compare_and_swap(x, 68, 76);
  compare_and_swap(x, 68, 72);
  compare_and_swap(x, 66, 74);
  compare_and_swap(x, 70, 78);
  compare_and_swap(x, 70, 74);
  compare_and_swap(x, 66, 68);
  compare_and_swap(x, 70, 72);
  compare_and_swap(x, 74, 76);
  compare_and_swap(x, 65, 73);
  compare_and_swap(x, 69, 77);
  compare_and_swap(x, 69, 73);
  compare_and_swap(x, 67, 75);
  compare_and_swap(x, 71, 79);
  compare_and_swap(x, 71, 75);
  compare_and_swap(x, 67, 69);
  compare_and_swap(x, 71, 73);
  compare_and_swap(x, 75, 77);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 67, 68);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 71, 72);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 75, 76);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 80, 81);
  compare_and_swap(x, 82, 83);
  compare_and_swap(x, 80, 82);
  compare_and_swap(x, 81, 83);
  compare_and_swap(x, 81, 82);
  compare_and_swap(x, 81, 82);
  compare_and_swap(x, 81, 82);
  compare_and_swap(x, 64, 80);
  compare_and_swap(x, 72, 80);
  compare_and_swap(x, 68, 72);
  compare_and_swap(x, 76, 80);
  compare_and_swap(x, 66, 82);
  compare_and_swap(x, 74, 82);
  compare_and_swap(x, 70, 74);
  compare_and_swap(x, 78, 82);
  compare_and_swap(x, 66, 68);
  compare_and_swap(x, 70, 72);
  compare_and_swap(x, 74, 76);
  compare_and_swap(x, 78, 80);
  compare_and_swap(x, 65, 81);
  compare_and_swap(x, 73, 81);
  compare_and_swap(x, 69, 73);
  compare_and_swap(x, 77, 81);
  compare_and_swap(x, 67, 83);
  compare_and_swap(x, 75, 83);
  compare_and_swap(x, 71, 75);
  compare_and_swap(x, 79, 83);
  compare_and_swap(x, 67, 69);
  compare_and_swap(x, 71, 73);
  compare_and_swap(x, 75, 77);
  compare_and_swap(x, 79, 81);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 67, 68);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 71, 72);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 75, 76);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 79, 80);
  compare_and_swap(x, 81, 82);
  compare_and_swap(x, 72, 80);
  compare_and_swap(x, 68, 72);
  compare_and_swap(x, 76, 80);
  compare_and_swap(x, 74, 82);
  compare_and_swap(x, 70, 74);
  compare_and_swap(x, 78, 82);
  compare_and_swap(x, 66, 68);
  compare_and_swap(x, 70, 72);
  compare_and_swap(x, 74, 76);
  compare_and_swap(x, 78, 80);
  compare_and_swap(x, 73, 81);
  compare_and_swap(x, 69, 73);
  compare_and_swap(x, 77, 81);
  compare_and_swap(x, 75, 83);
  compare_and_swap(x, 71, 75);
  compare_and_swap(x, 79, 83);
  compare_and_swap(x, 67, 69);
  compare_and_swap(x, 71, 73);
  compare_and_swap(x, 75, 77);
  compare_and_swap(x, 79, 81);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 67, 68);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 71, 72);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 75, 76);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 79, 80);
  compare_and_swap(x, 81, 82);
  compare_and_swap(x, 0, 64);
  compare_and_swap(x, 32, 64);
  compare_and_swap(x, 16, 80);
  compare_and_swap(x, 48, 80);
  compare_and_swap(x, 16, 32);
  compare_and_swap(x, 48, 64);
  compare_and_swap(x, 8, 72);
  compare_and_swap(x, 40, 72);
  compare_and_swap(x, 24, 40);
  compare_and_swap(x, 56, 72);
  compare_and_swap(x, 8, 16);
  compare_and_swap(x, 24, 32);
  compare_and_swap(x, 40, 48);
  compare_and_swap(x, 56, 64);
  compare_and_swap(x, 72, 80);
  compare_and_swap(x, 4, 68);
  compare_and_swap(x, 36, 68);
  compare_and_swap(x, 20, 36);
  compare_and_swap(x, 52, 68);
  compare_and_swap(x, 12, 76);
  compare_and_swap(x, 44, 76);
  compare_and_swap(x, 28, 44);
  compare_and_swap(x, 60, 76);
  compare_and_swap(x, 12, 20);
  compare_and_swap(x, 28, 36);
  compare_and_swap(x, 44, 52);
  compare_and_swap(x, 60, 68);
  compare_and_swap(x, 4, 8);
  compare_and_swap(x, 12, 16);
  compare_and_swap(x, 20, 24);
  compare_and_swap(x, 28, 32);
  compare_and_swap(x, 36, 40);
  compare_and_swap(x, 44, 48);
  compare_and_swap(x, 52, 56);
  compare_and_swap(x, 60, 64);
  compare_and_swap(x, 68, 72);
  compare_and_swap(x, 76, 80);
  compare_and_swap(x, 2, 66);
  compare_and_swap(x, 34, 66);
  compare_and_swap(x, 18, 82);
  compare_and_swap(x, 50, 82);
  compare_and_swap(x, 18, 34);
  compare_and_swap(x, 50, 66);
  compare_and_swap(x, 10, 74);
  compare_and_swap(x, 42, 74);
  compare_and_swap(x, 26, 42);
  compare_and_swap(x, 58, 74);
  compare_and_swap(x, 10, 18);
  compare_and_swap(x, 26, 34);
  compare_and_swap(x, 42, 50);
  compare_and_swap(x, 58, 66);
  compare_and_swap(x, 74, 82);
  compare_and_swap(x, 6, 70);
  compare_and_swap(x, 38, 70);
  compare_and_swap(x, 22, 38);
  compare_and_swap(x, 54, 70);
  compare_and_swap(x, 14, 78);
  compare_and_swap(x, 46, 78);
  compare_and_swap(x, 30, 46);
  compare_and_swap(x, 62, 78);
  compare_and_swap(x, 14, 22);
  compare_and_swap(x, 30, 38);
  compare_and_swap(x, 46, 54);
  compare_and_swap(x, 62, 70);
  compare_and_swap(x, 6, 10);
  compare_and_swap(x, 14, 18);
  compare_and_swap(x, 22, 26);
  compare_and_swap(x, 30, 34);
  compare_and_swap(x, 38, 42);
  compare_and_swap(x, 46, 50);
  compare_and_swap(x, 54, 58);
  compare_and_swap(x, 62, 66);
  compare_and_swap(x, 70, 74);
  compare_and_swap(x, 78, 82);
  compare_and_swap(x, 2, 4);
  compare_and_swap(x, 6, 8);
  compare_and_swap(x, 10, 12);
  compare_and_swap(x, 14, 16);
  compare_and_swap(x, 18, 20);
  compare_and_swap(x, 22, 24);
  compare_and_swap(x, 26, 28);
  compare_and_swap(x, 30, 32);
  compare_and_swap(x, 34, 36);
  compare_and_swap(x, 38, 40);
  compare_and_swap(x, 42, 44);
  compare_and_swap(x, 46, 48);
  compare_and_swap(x, 50, 52);
  compare_and_swap(x, 54, 56);
  compare_and_swap(x, 58, 60);
  compare_and_swap(x, 62, 64);
  compare_and_swap(x, 66, 68);
  compare_and_swap(x, 70, 72);
  compare_and_swap(x, 74, 76);
  compare_and_swap(x, 78, 80);
  compare_and_swap(x, 1, 65);
  compare_and_swap(x, 33, 65);
  compare_and_swap(x, 17, 81);
  compare_and_swap(x, 49, 81);
  compare_and_swap(x, 17, 33);
  compare_and_swap(x, 49, 65);
  compare_and_swap(x, 9, 73);
  compare_and_swap(x, 41, 73);
  compare_and_swap(x, 25, 41);
  compare_and_swap(x, 57, 73);
  compare_and_swap(x, 9, 17);
  compare_and_swap(x, 25, 33);
  compare_and_swap(x, 41, 49);
  compare_and_swap(x, 57, 65);
  compare_and_swap(x, 73, 81);
  compare_and_swap(x, 5, 69);
  compare_and_swap(x, 37, 69);
  compare_and_swap(x, 21, 37);
  compare_and_swap(x, 53, 69);
  compare_and_swap(x, 13, 77);
  compare_and_swap(x, 45, 77);
  compare_and_swap(x, 29, 45);
  compare_and_swap(x, 61, 77);
  compare_and_swap(x, 13, 21);
  compare_and_swap(x, 29, 37);
  compare_and_swap(x, 45, 53);
  compare_and_swap(x, 61, 69);
  compare_and_swap(x, 5, 9);
  compare_and_swap(x, 13, 17);
  compare_and_swap(x, 21, 25);
  compare_and_swap(x, 29, 33);
  compare_and_swap(x, 37, 41);
  compare_and_swap(x, 45, 49);
  compare_and_swap(x, 53, 57);
  compare_and_swap(x, 61, 65);
  compare_and_swap(x, 69, 73);
  compare_and_swap(x, 77, 81);
  compare_and_swap(x, 3, 67);
  compare_and_swap(x, 35, 67);
  compare_and_swap(x, 19, 83);
  compare_and_swap(x, 51, 83);
  compare_and_swap(x, 19, 35);
  compare_and_swap(x, 51, 67);
  compare_and_swap(x, 11, 75);
  compare_and_swap(x, 43, 75);
  compare_and_swap(x, 27, 43);
  compare_and_swap(x, 59, 75);
  compare_and_swap(x, 11, 19);
  compare_and_swap(x, 27, 35);
  compare_and_swap(x, 43, 51);
  compare_and_swap(x, 59, 67);
  compare_and_swap(x, 75, 83);
  compare_and_swap(x, 7, 71);
  compare_and_swap(x, 39, 71);
  compare_and_swap(x, 23, 39);
  compare_and_swap(x, 55, 71);
  compare_and_swap(x, 15, 79);
  compare_and_swap(x, 47, 79);
  compare_and_swap(x, 31, 47);
  compare_and_swap(x, 63, 79);
  compare_and_swap(x, 15, 23);
  compare_and_swap(x, 31, 39);
  compare_and_swap(x, 47, 55);
  compare_and_swap(x, 63, 71);
  compare_and_swap(x, 7, 11);
  compare_and_swap(x, 15, 19);
  compare_and_swap(x, 23, 27);
  compare_and_swap(x, 31, 35);
  compare_and_swap(x, 39, 43);
  compare_and_swap(x, 47, 51);
  compare_and_swap(x, 55, 59);
  compare_and_swap(x, 63, 67);
  compare_and_swap(x, 71, 75);
  compare_and_swap(x, 79, 83);
  compare_and_swap(x, 3, 5);
  compare_and_swap(x, 7, 9);
  compare_and_swap(x, 11, 13);
  compare_and_swap(x, 15, 17);
  compare_and_swap(x, 19, 21);
  compare_and_swap(x, 23, 25);
  compare_and_swap(x, 27, 29);
  compare_and_swap(x, 31, 33);
  compare_and_swap(x, 35, 37);
  compare_and_swap(x, 39, 41);
  compare_and_swap(x, 43, 45);
  compare_and_swap(x, 47, 49);
  compare_and_swap(x, 51, 53);
  compare_and_swap(x, 55, 57);
  compare_and_swap(x, 59, 61);
  compare_and_swap(x, 63, 65);
  compare_and_swap(x, 67, 69);
  compare_and_swap(x, 71, 73);
  compare_and_swap(x, 75, 77);
  compare_and_swap(x, 79, 81);
  compare_and_swap(x, 1, 2);
  compare_and_swap(x, 3, 4);
  compare_and_swap(x, 5, 6);
  compare_and_swap(x, 7, 8);
  compare_and_swap(x, 9, 10);
  compare_and_swap(x, 11, 12);
  compare_and_swap(x, 13, 14);
  compare_and_swap(x, 15, 16);
  compare_and_swap(x, 17, 18);
  compare_and_swap(x, 19, 20);
  compare_and_swap(x, 21, 22);
  compare_and_swap(x, 23, 24);
  compare_and_swap(x, 25, 26);
  compare_and_swap(x, 27, 28);
  compare_and_swap(x, 29, 30);
  compare_and_swap(x, 31, 32);
  compare_and_swap(x, 33, 34);
  compare_and_swap(x, 35, 36);
  compare_and_swap(x, 37, 38);
  compare_and_swap(x, 39, 40);
  compare_and_swap(x, 41, 42);
  compare_and_swap(x, 43, 44);
  compare_and_swap(x, 45, 46);
  compare_and_swap(x, 47, 48);
  compare_and_swap(x, 49, 50);
  compare_and_swap(x, 51, 52);
  compare_and_swap(x, 53, 54);
  compare_and_swap(x, 55, 56);
  compare_and_swap(x, 57, 58);
  compare_and_swap(x, 59, 60);
  compare_and_swap(x, 61, 62);
  compare_and_swap(x, 63, 64);
  compare_and_swap(x, 65, 66);
  compare_and_swap(x, 67, 68);
  compare_and_swap(x, 69, 70);
  compare_and_swap(x, 71, 72);
  compare_and_swap(x, 73, 74);
  compare_and_swap(x, 75, 76);
  compare_and_swap(x, 77, 78);
  compare_and_swap(x, 79, 80);
  compare_and_swap(x, 81, 82);
}
