<?php
	define('IMPL', 'Haswell');

	function dieUsage() {
		echo 'Usage: php ', $argv[0], " \33[4mop\33[0m \33[4mdake\33[0m \33[4mqr\33[0m\n";
		echo "\n";
		echo "\33[4mop\33[0m is one of \"keygen\" or \"kex\".\n";
		echo "\33[4mdake\33[0m is a valid DAKE parameter for dakes-benchmark.\n";
		echo "\33[4mqr\33[0m is a valid QR parameter for dakes-benchmark.\n";
		die;
	}

	if (count($argv) != 4) dieUsage();
	
	$benchmark = dirname(__FILE__).'/../impl/Benchmark_'.IMPL.'/dakes-benchmark';
	if (!is_executable($benchmark)) die('Could not execute benchmark binary at '.$benchmark);
	
	$op = $argv[1];
	$dake = $argv[2];
	$qr = $argv[3];
	
	if ($op != 'keygen' && $op != 'kex') dieUsage();
	if (!preg_match('/^[a-z0-9+\-]{1,15}$/', $dake)) dieUsage();
	if (!preg_match('/^[a-z0-9+\-]{1,15}$/', $qr)) dieUsage();
	
	if (!file_exists('logs')) mkdir('logs');
	
	$logName = 'logs/'.$op.'-'.$dake.'-'.$qr.'.csv';
	$log = fopen($logName, 'ab');
	if ($log === false) die("Could not open log file:\n".$logName."\n");
	
	$command = $benchmark.' '.escapeshellarg($op).' '.escapeshellarg($dake).' '.escapeshellarg($qr);
	echo 'Running ',$command,"\n";
	
	for ($i = 1; $i <= 100000; ++$i) {
		$proc = proc_open($command, array(0 => array('pipe', 'r'), 1 => array('pipe', 'w'), 2 => array('pipe', 'w')), $pipes);
		if ($proc === false || !is_resource($proc)) {
			die("Could not launch command:\n".$command."\n");
		}
		
		if (fgetc($pipes[1]) !== '?') {
			die("Benchmark program did not report readiness.\n");
		}
		fwrite($pipes[0], "\n");
		$result = fgets($pipes[1]);
		fwrite($log, $result);
		
		if (($i % 1000) == 0) {
			echo '.';
			flush();
		}
		proc_close($proc);
	}
	
	fclose($log);
	echo "\n";
?>
